code segment
     assume cs:code
     org 100h
begin:
     call init
; ஢ઠ  
kb:  mov ah, 1
     int 16h
     jz kb
;  ᪠   ASCII    AX
     mov ah, 0
     int 16h
; ᫨   ESC - 室  ணࠬ
     cmp al, 27
     je exit
; 뫪 ASCII  
     push ax
     mov bl, al
     call send
     pop ax
; 뫪   
     mov bl, ah
     call send
;   
     mov ax, 0B800h
     mov es, ax
     xor di, di
     mov cx, 4000
; 祭   
mem: push cx
     call get
;    
     stosb
     pop cx
     loop mem
     jmp kb
exit:
; 襭 ࠡ ணࠬ - 室  DOS
     mov ax, 4C00h
     int 21h

; 楤 樠樨 LPT 
init proc near
; 頥 뢠  LPT 
     mov dx, 37Ah
     and al, 11101111b
     out dx, al
     in al, 21h
     or al, 10000000b
     out 21h, al
; ⠭  0  室 ᨣ
     mov dx, 378h
     xor al, al
     out dx, al
     ret
init endp

; 楤 뫪   BL
send proc near
; 뫪 襣 㡠
     push bx
     and bl, 0Fh
     call sendb
     pop bx
; 뫪 襣 㡠
     mov cl, 4
     shr bl, cl
     call sendb
     ret
send endp

; 楤 뫪 㡠  BL
sendb proc near
;   ᨣ ACK
     mov dx, 379h
m1:  in al, dx
     test al, 40h
     jnz m1
; ⠢ 
     mov al, bl
     shl al, 1
     and al, 00010000b
     or al, bl
     and al, 00010111b
     mov dx, 378h
     out dx, al
; ⠢ ᨣ ACK
     or al, 08h
     out dx, al
;  室 ᨣ ACK
     mov dx, 379h
m2:  in al, dx
     test al, 40h
     jz m2
; ᨬ ᨣ ACK  
     xor al, al
     mov dx, 378h
     out dx, al
;   ᨣ ACK
     mov dx, 379h
m8:  in al, dx
     test al, 40h
     jnz m8
     ret
sendb endp

; 楤 祭   AL
get proc near
; 祭 襣 㡠
     call getb
     mov cl, bl
; 祭 襣 㡠
     push cx
     call getb
     pop cx
     mov al, cl
     mov cl, 4
     shl bl, cl
     or al, bl
     ret
get endp

; 楤 祭 㡠  BL
getb proc near
;  室 ᨣ ACK
     mov dx, 379h
m3:  in al, dx
     test al, 40h
     jz m3
; ਭ 
     in al, dx
     xor al, 80h
     mov cl, 3
     shr al, cl
     mov bl, al
     and bl, 07h
     shr al, 1
     and al, 00001000b
     or bl, al
; ⠭ ᨣ ACK
     mov al, 08h
     mov dx, 378h
     out dx, al
;   ᨣ ACK
     mov dx, 379h
m4:  in al, dx
     test al, 40h
     jnz m4
; ᨬ ᨣ ACK
     mov dx, 378h
     xor al, al
     out dx, al
     ret
getb endp

code ends
     end begin
